clear global
clear all
close all
clc

%CREATE WORLD
%reading data & display

world_dim=input('Define world ([x_min x_max y_min y_max]): ');
obs_no=input('Number of obstacles: ');

fprintf('\tDefine the objects\n(left-click picks a vertex,\nright-click picks the last vertex of the current object)\n\n')
pause(2);

scrsz = get(0,'ScreenSize'); %rezolutia display-ului (pt a maximiza figurile)
scrsz(4)=scrsz(4)-72; %inaltimea meniului figurii este 72 pixeli (asa mi-a iesit din calcul)

init_wrld_h=figure(); %handle al figurii cu lumea initiala
set(init_wrld_h,'Position',scrsz); %maximizam figura
axis(world_dim);
title('Obstacle vertices')
hold on
grid
%read obstacle's vertices & create their convex-hulls
for i=1:obs_no   %i = object number
    j=1; %j = no. of vertexes for current object
    but=1;
    while but==1
        [x,y,but]=ginput(1);
        plot(x,y,'.k')
        object{i}(:,j)=[x;y];
        j=j+1;
    end
    j=convhull(object{i}(1,:),object{i}(2,:));
    object{i}=object{i}(:,j(1:length(j)-1));
    fill(object{i}(1,:),object{i}(2,:),'k') %or functia patch (similara cu fill)
end
pause(1)
set(init_wrld_h,'Visible','off') %ascundem fig initiala (nu avem nevoie deocamdata de ea)

%unicyc vertices
%unicyc=input('Give the unicyc''s vertices with respect to its centroid ([x11 x12 ... x1n ; y11 y12 ... y1n]): ');

er=1; %pt a testa daca centrul robotului este cuprind in poligonul definit
d_x=world_dim(2)-world_dim(1); %dimensiunile lumii
d_y=world_dim(4)-world_dim(3);
while er==1
    robo=figure();
    d_m=min(d_x,d_y);
    axis([-d_m d_m -d_m d_m]/10); %am pp ca robotul nu va avea dimensiuni mai mari decit o cincime din latura minima a world
    axis('square');
    title('Unicycle vertices with respect to its centroid, suposing unicycle oriented to upper bound')
    xlabel('Left-click picks a vertex, right-click picks the last vertex')
    hold on
    grid
    plot([0 0],[0 d_m/20],'k','LineWidth',2);
    plot(0,d_m/20,'k^','MarkerSize',10);
    plot(0,0,'ob')

    j=1;
    but=1;
    while but==1
        [x,y,but]=ginput(1);
        plot(x,y,'.r')
        unicyc(:,j)=[x;y];
        j=j+1;
    end

    %create convex unicyc & draw it
    pause(0.3)
    j=convhull(unicyc(1,:),unicyc(2,:));
    unicyc=unicyc(:,j(1:length(j)-1));
    if ~inpolygon(0,0,unicyc(1,:),unicyc(2,:)) %centrul nu este in interiorul robotului
        close(robo)
        fprintf('\n\nThe unicyc centroid must be inside the convex hull defined by its vertices!\nPlease try again.\n')
        pause(1)
        continue
    else
        fill(unicyc(1,:),unicyc(2,:),'r')
        plot([0 0],[0 d_m/20],'k','LineWidth',2);
        plot(0,d_m/20,'k^','MarkerSize',10);
        plot(0,0,'ob')
        er=0;
    end
end
pause(0.5)
set(robo,'Visible','off')
n=input('Number of vertices of the polygon supposed to contain the unicycle: ');
epsilon=input('Distance from center to observable point: ');
%cream un poligon (cu n laturi) care incadreaza unicycle-ul, oricum ar fi acesta rotit fata de punctul OBSERVABIL (vezi formule caiet)
D=max(sqrt(unicyc(1,:).^2+(unicyc(2,:)-epsilon).^2))/sin((1-2/n)*pi/2); %distanta de la punctul obs. la un virf al poligonului
%epsilon=min(sqrt(unicyc(1,:).^2+unicyc(2,:).^2))/10; %dist de la centru la punctul observabil
alfa=2*pi*((1:n)-1)/n;
robot=D*[cos(alfa);sin(alfa)]; %"robot" va juca rolul robotului care nu se roteste
set(robo,'Visible','on')
title('Poligon surrounding the unicycle')
rob_h=fill(robot(1,:),robot(2,:)+epsilon,'y');
set(rob_h,'FaceAlpha',0.5);
plot(0,epsilon,'ok','MarkerSize',10)
pause(1)
close(robo)
theta0=input('The initial angle theta of the unicycle: ');

%toate calculele (pina spre sfirsitul programului) se vor referi la PUNCTUL OBSERVABIL al unicycle-ului
%dupa ce obtinem viteza punctului observabil, vom afla viteza de translatie si de rotatie a unicycle-ului

%convex-hull-ul care limiteaza viteza mobilului (matricea U va contine virfurile)
er=1;
while er==1
    spd_h=figure();
    axis([-d_x d_x -d_y d_y]/2); %am pp ca robotul poate parcurge lumea pe o directie in minim aprox. 2 sec
    title('Define the robot''s speed boundaries(convex polygon containing the origin)')
    xlabel('Left-click picks a vertex, right-click picks the last vertex')
    hold on
    grid
    plot(0,0,'.b')

    j=1;
    but=1;
    while but==1
        [x,y,but]=ginput(1);
        plot(x,y,'.r')
        U(:,j)=[x;y];
        j=j+1;
    end

    %create convex speed limit & draw it
    pause(0.3)
    j=convhull(U(1,:),U(2,:));
    U=U(:,j(1:length(j)-1));
    if ~inpolygon(0,0,U(1,:),U(2,:)) %originea nu este in U
        close(spd_h)
        fprintf('\n\nThe origin must be contained in the defined polygon!\nPlease try again.\n')
        pause(1)
        continue
    else
        fill(U(1,:),U(2,:),'y')
        plot(0,0,'ok')
        plot([-d_x/2 d_x/2],[0 0],'k')
        plot([0 0],[-d_y/2 d_y/2],'k')
        er=0;
    end
end
pause(0.5)
set(spd_h,'Visible','off')


%MODIFY WORLD BOUNDARIES AND OBJECTS
%(in order to shrink the robot to its centroid)
pause(1)
wrld = world_dim - [min(robot(1,:)) max(robot(1,:)) min(robot(2,:)) max(robot(2,:))];
set(init_wrld_h,'Visible','on')
wrld_h=fill([wrld(1) wrld(2) wrld(2) wrld(1)],[wrld(3) wrld(3) wrld(4) wrld(4)],'w');
set(wrld_h,'FaceAlpha',0);  %transparent

obstacle=cell(1,obs_no);
for i=1:obs_no                  %for each obstacle
    for j=1:size(object{i},2)      %for each vertex of the object
        for k=1:size(robot,2)     %for each vertex of robot (in its coordinate system)
            obstacle{i}=[obstacle{i} object{i}(:,j)-robot(:,k)];
        end
    end
    l=convhull(obstacle{i}(1,:),obstacle{i}(2,:));
    obstacle{i}=obstacle{i}(:,l(1:length(l)-1));
    pause(0.2)
    h=fill(obstacle{i}(1,:),obstacle{i}(2,:),'c');
    set(h,'FaceAlpha',0.5);
end
pause(1)
set(init_wrld_h,'Visible','off')


%new world and obstacles
new_w_h=figure(); %handle-ul la figura care contine obstacolele marite
set(new_w_h,'Position',scrsz);
axis(wrld);
title('Shrinked world and enlarged obstacles (robot is reduced to its centroid)')
hold on
for i=1:obs_no
    fill(obstacle{i}(1,:),obstacle{i}(2,:),'k')
end


%BINARIZE NEW WORLD WITH ENLARGED OBSTACLES
%(in order to perform rectangular decomposition)
clc
set(new_w_h,'Visible','off') %ascunderea figurii, pt a vedea command window
m=input('Resolution on horizontal dimension (in percent, aprox. value): [%] ');
n=input('Resolution on vertical dimension (in percent, aprox. value): [%] ');

m=2^round(log2(100/m)); %nr de pixeli pe orizontala va fi (m)
n=2^round(log2(100/n)); %nr de pixeli pe verticala va fi (n)

fprintf('\nBinarized image (hidden from user) will have %g x %g pixels\n\n\n',n,m);
pause(0.5);
dt=input('Pasul de integrare: ')

%set(new_w_h,'Visible','on')

global WORLD
WORLD=ones(n,m);

%transform coordinates from (real) new world to indices in binary matrix WORLD
%vezi formulele in caiet

d_x=wrld(2)-wrld(1);
d_y=wrld(4)-wrld(3);
x_min=wrld(1);
y_max=wrld(4);
dx=d_x/(m-1);
dy=d_y/(n-1);

for i=1:obs_no
    v_oriz=round((obstacle{i}(1,:)-x_min)/dx+1); %coordonatele virfurilor in discret
    v_vert=round((y_max-obstacle{i}(2,:))/dy+1); %formulele sunt deduse in caiet (oriz-coloana, vert-linie)
    WORLD=WORLD-roipoly(WORLD,v_oriz,v_vert);
end
WORLD=double(uint8(WORLD)); %pt a face zero valorile negative (unde eventual se suprapun obiectele)

%citirea pozitiilor de start si de stop
fprintf('\n\nSelect the start and then the end position of robot''s controid\n')
pause(1)
figure(init_wrld_h)
er=1;
while er==1
    xlabel('Select the start position (of observable point)')
    start=ginput(1)';
    start_b=round((start(1)-x_min)/dx+1); %coordonatele punctului de start in discret
    start_a=round((y_max-start(2))/dy+1); %a-linie (pe vert), b-coloana (pe oriz)
    if WORLD(start_a,start_b)==0
        commandwindow
        fprintf('\n\nThe robot can''t start from the inside an obstacle! Please try again.\n')
        pause(1)
        figure(init_wrld_hh)
        continue
    else
        start_h=plot(start(1),start(2),'dg','MarkerSize',10,'LineWidth',2);
        er=0;
    end
end
er=1;
while er==1
    xlabel('Select the stop position (of observable point)')
    stop=ginput(1)';
    stop_b=round((stop(1)-x_min)/dx+1);
    stop_a=round((y_max-stop(2))/dy+1);
    if WORLD(stop_a,stop_b)==0
        commandwindow
        fprintf('\n\nThe robot can''t stop inside an obstacle! Please try again.\n')
        pause(1)
        figure(init_wrld_h)
        continue
    else
        stop_h=plot(stop(1),stop(2),'xg','MarkerSize',10,'LineWidth',2);
        er=0;
    end
end
xlabel('')
clc
set(init_wrld_h,'Visible','off')

%DESCOMPUNEREA IN DREPTUNGHIURI (dupa ideea quadtrees)

global Q POZ % POZ va contine coordonatele dreptunghiurilor libere

Q=cell(size(WORLD)); %n = precizia pe vert, m = precizia pe orizontala (WORLD=matrice cu valorile 1 si 0)
                     %WORLD are dimens n x m; valoare 1 - liber; %valoare 0 - ocupat
Q{1,1}.coord=[1;1];
Q{1,1}.dim=size(WORLD)';
s=sum(sum(WORLD));   %var tempor.

%descompunerea in dreptunghiuri (functia split4 se va apela recursiv)
%in matricea (cu 2 linii) POZ vor fi memorate coordonatele colturilor
%stinga-sus ale dreptunghiurilor libere

if (s > 0) & (s < prod(size(WORLD))) %partial ocupat
    split4(1,1); %descompune
elseif (s == 0) %total ocupat
    [Q{:,:}]=deal(0);
    disp('ERROR - Everything is occupied!')
else %liber
    dims=size(WORLD)';
    [Q{dims(1),1}.coord Q{dims(1),dims(2)}.coord Q{1,dims(2)}.coord]=deal(Q{1,1}.coord);
    POZ=[POZ [1;1]];
    disp('ERROR - Everything is free!')
end

set(new_w_h,'Visible','on')
%reprezentarea primei descompuneri in dreptunghiuri
nr_d=size(POZ,2); %nr de dreptunghiuri
for i=1:nr_d
    plot_desc(i,dx,dy,x_min,y_max,'b');
end


%CONSTRUIREA MATRICEI DE ADIACENTA
%si reprezentarea grafului

global ADIACENT ADIAC_W
ADIACENT=zeros(nr_d); %matrice pt retinut adiacenta (poate fi transformata in sparse)
ADIAC_W=Inf(nr_d); %matrice pt retinut adiacenta, cu inversele ariilor drept ponderi (aria drept. in care se ajunge)
%(matricea ADIAC_W poate fi transformata in sparse daca nu e memorie suficienta)
coord_r=zeros(nr_d,2); %matrice care va contine coordonatele in lumea reala ale centrelor dreptunghiurilor (pt reprezentarea grafului)

for i=1:nr_d
    a=POZ(1,i);
    b=POZ(2,i);
    dims=Q{a,b}.dim;
    coord_r(i,:)=[((2*b+dims(2)-3)*dx/2+x_min) (y_max-(2*a+dims(1)-3)*dy/2)]; %coordonatele centrului dreptunghiului i (in continuu)
    aria=(dims(1)-1)*(dims(2)-1)*dx*dy; %aria dreptunghiului curent
    perim=2*((dims(1)-1)*dy+(dims(2)-1)*dx); %perimetrul drept. curent
    
    vecini=adiacenta(i); %functia adiacenta intoarce vecinii dreptunghiului i (cu coordonatele POZ(:,i))
    ADIACENT(vecini,i)=1;
    %vom cauta calea cu cost minim; dorim sa mergem prin dreptunghiuri destul de mari
    %costul va fi (perimetru/arie) (la tranzitiile spre dreptunghiulcurent);
    % daca aria=0 (dreptunghi minim), costul va fi Inf (pt a nu merge niciodata prin dreptunghiurile minime (chiar linga obstacole)
    if aria~=0
        %ADIAC_W(vecini,i)=perim/aria;
        ADIAC_W(vecini,i)=2*(dims(1)+dims(2))/(dims(1)*dims(2)); %perim/arie calculata binar - pt a elimina erorile de conversie
        %ADIAC_W(vecini,i)=1; %*** daca dorim calea cea mai scurta
    else
        ADIAC_W(vecini,i)=Inf;
    end
end

gplot(ADIACENT,coord_r,'.:r') %reprezentarea grafului

plot(start(1),start(2),'dg','MarkerSize',10,'LineWidth',2);
plot(stop(1),stop(2),'xg','MarkerSize',10,'LineWidth',2);

%gasirea dreptunghiului de start si a celui de stop
for i=1:nr_d
    a=POZ(1,i);
    b=POZ(2,i);
    dims=Q{a,b}.dim;
    if (start_a >= a) & (start_a <= a+dims(1)-1) & (start_b >= b) & (start_b <= b+dims(2)-1)
        dr_start=i; %indicele dreptunghiului de start
    end
    if (stop_a >= a) & (stop_a <= a+dims(1)-1) & (stop_b >= b) & (stop_b <= b+dims(2)-1)
        dr_stop=i;
    end
end

if dr_start~=dr_stop
    cale=find_path(dr_start,dr_stop); %gasirea caii start-stop
else
    cale=dr_start; %raminem in acelasi dreptunghi
end
nr_d=length(cale); %update nr de dreptunghiuri

%reprezentarea caii (prin dreptunghiurile mari)
if nr_d~=1
    for i=1:nr_d-1
        path_h(i)=plot([coord_r(cale(i),1),coord_r(cale(i+1),1)],[coord_r(cale(i),2),coord_r(cale(i+1),2)],'--Og','LineWidth',2,'MarkerSize',10);
        pause(0.05)
    end
elseif cale~=0 %lungimea caii este 1, deci raminem in acelasi dreptunghi
    path_h=plot(coord_r(cale(1),1),coord_r(cale(1),2),'--g','LineWidth',2);
else
    xlabel('Path start->stop not found; maybe you want to go through a too small rectangle');
    fprintf('\n\nPath start->stop not found; maybe you want to go through a too small rectangle\n\n');
end

%taierea dreptunghiurilor prea mari de pe cale (explicatii in caiet)
if nr_d~=1 %evitam cazurile cind raminem in acelasi drept. sau nu am gasit o cale
    cale=split_path_dr(cale,start_a,start_b); %taierea pt a trece din drept. mici in mari (parcurgem calea in sens invers)
    cale=fliplr(split_path_dr(fliplr(cale),stop_a,stop_b)); %parcurgem calea in sens direct, pt a trece prin drept. cu laturile adiacente egale
end
nr_d=length(cale); %nr de drept. din calea finala

%noua cale va contine alte dreptunghiuri;
%reprezentam noile dreptunghiuri (doar pe cele din cale) cu alte culori

delete(path_h); %stergem vechea cale
pause(0.5);

for i=cale %indicii dreptunghiurilor sint in vectorul cale
    plot_desc(i,dx,dy,x_min,y_max,'c');
end
pause(1)
clc


%DE AICI VOM LUCRA NUMAI IN DOMENIUL REAL (CONTINUU)

%procesarea caii obtinute - vom avea o matrice cu coordonatele drept. si
%un vector cu directiile pe care iesim din fiecare dreptunghi
[coord,dir]=proc_path(cale,dx,dy,x_min,y_max,m,n);

%desenam dreptunghiurile de pe cale si in figura initiala
set(init_wrld_h,'Visible','on') %prima figura (cu obstacole marite)
start_h=plot(start(1),start(2),'dg','MarkerSize',10,'LineWidth',2);
for i=1:nr_d
    x1=coord(i,1);
    x2=coord(i,2);
    y1=coord(i,3);
    y2=coord(i,4);
    plot([x1 x2 x2 x1 x1],[y1 y1 y2 y2 y1],'b');
    pause(0.05);
end
stop_h=plot(stop(1),stop(2),'xg','MarkerSize',10,'LineWidth',2);

%parcurgerea caii si ALEGEREA valorilor g11,g1,g22,g21 la virfurile fiecarui
%drepunghi a.i. sa avem o traiectore smooth
%si in dreptnghiul final sa avem drept punct de echilibru punctul "stop"
G=alege_g_dir(coord,dir,U,stop);

%reprezentarea vector-fieldului in dreptunghiuri
%dx=(wrld(2)-wrld(1))/75; %daca dorim sa specificam in aprox. cite puncte sa reprez. v.f. (pe oriz, resp vert)
%dy=(wrld(4)-wrld(3))/50;
for i=1:nr_d
    plot_vf(coord(i,:),G{i},2*dx,2*dy,'k');
end

%rezolvarea ec. diferent. dx/dt=f(x) si aflarea traseului in fiecare dreptunghi din cale
%vom obtine un vector cu momentele de timp, o matrice cu 2 linii cu
%pozitiile la momentele din vect. timp si o matrice cu 2 linii cu vitezele la momentele de timp
d_min=norm([dx;dy])/10; %consideram distanta minima o fractiune din lungimea diagonalei unui pixel (dx,dy-precizia aleasa la binarizare)
%integram separat pt primul drept. (pt a avea vectorii initiali timp,pozitia,viteza)
%plecam din punctul de start
[timp,pozitia,viteza]=traseu_pas_cst(start,coord(1,:),G{1},stop,d_min,dt);
for i=2:nr_d
    p_init=pozitia(:,end); %punctul din care plecam in fiecare drept. este ultimul punct atins in drept. precedent
    if norm(p_init-stop)<=d_min %punctul de stop e f aproape de marginea ultimului drept., nu mai integram in acest caz
        break
    end
    [t,poz,vit]=traseu_pas_cst(p_init,coord(i,:),G{i},stop,d_min,dt);
    timp=[timp timp(end)+t(2:end)]; %timpul trebuie exprimat "global"
    pozitia=[pozitia poz(:,2:end)]; %prima coloana din t si poz este egala cu ultima din timp si pozitii
    viteza=[viteza vit(:,2:end)]; %in viteza pot exista salturi, insa eliminam vit(:,1) pt a avea o situatie reala (o singura viteza a un moment de timp bine precizat)
end

%reprezentarea traseului urmat de punctul observabil al mobilului (pe figura cu obstacolele marite)
%viteza de reprezentare a pozitiei va fi proportionala cu viteza reala de miscare
ft=max(timp)/3; %factorul de "restringere" a timpului - pauzele vor dura aprox. 3 secunde
plot(pozitia(1,1),pozitia(2,1),'.r')
for i=2:size(pozitia,2)
    plot(pozitia(1,(i-1:i)),pozitia(2,(i-1:i)),':.r')
end
pause(1)

%reprezentarea vitezelor pe axe ale punctului observabil (in alta figura)
vit_h=figure();
set(vit_h,'Position',scrsz);
subplot(211);
plot(timp,viteza(1,:),'.k')
xlabel('Horizontal observable point speed projection')
subplot(212);
plot(timp,viteza(2,:),'.k')
xlabel('Vertical observable point speed projection')
pause(1.5);


%de aici revenim la MISCAREA UNICYCLE-ului
%aflarea modului de miscare al unicycle-ului (sist. de ec dif. - vezi formule in caiet)
%st-vector de stare de forma [dx;dy;theta], dx,dy-componentele vectorului centrului unicycle-ului
start_c=start-epsilon*[cos(theta0);sin(theta0)]; %de unde porneste centrul unicycl.
[st]=traseu_unicyc([start_c;theta0],timp,viteza,epsilon); %functie care rezolva sist de ec dif

for i=1:length(timp) %viteza de translatie, resp rotatie a unicycle-ului
    v_unic(:,i)=[cos(st(3,i)) sin(st(3,i));-sin(st(3,i))/epsilon cos(st(3,i))/epsilon]*viteza(:,i);
end

vit_unic_h=figure();
set(vit_unic_h,'Position',scrsz);
subplot(211);
plot(timp,v_unic(1,:),'.k')
xlabel('"Forward speed" of unicycle')
subplot(212);
plot(timp,v_unic(2,:),'.k')
xlabel('"Rotation speed" of unicycle')
pause(1.5);

%reprezentarea domeniului in care sint vitezele
set(spd_h,'Visible','on')
title('Resulted observable point''s speed boundaries (convex polygon containing the origin)')
xlabel(' ')
Gx=[]; %valorile proiectiilor vitezelor (pt a reprezenta conv hull-ul in care cuprinde toate vitezele posibile
Gy=[];
for i=1:nr_d
    Gx=[Gx G{i}(1,:)];
    Gy=[Gy G{i}(2,:)];
end
j=convhull(Gx,Gy);
Gx=Gx(:,j(1:length(j)-1));
Gy=Gy(:,j(1:length(j)-1));
fill(Gx,Gy,'b')
plot(0,0,'ok')
plot([-d_x/2 d_x/2],[0 0],'k')
plot([0 0],[-d_y/2 d_y/2],'k')
pause(1.5)

%aflarea coordonatelor unicyclului in timp (in sistemul propriu unicycle-ului - folosind matricea de rotatie)
for i=1:length(timp)
    coord_u{i}=[cos(st(3,i)-pi/2) -sin(st(3,i)-pi/2);sin(st(3,i)-pi/2) cos(st(3,i)-pi/2)]*unicyc;
end

%reprezentarea (in timp) a miscarii mobilului in lumea initiala
world_h=figure();
set(world_h,'Position',scrsz);
axis(world_dim);
axis('square');
hold on
title('The movement of the unicycle in the initial world')
for i=1:obs_no
    fill(object{i}(1,:),object{i}(2,:),'k') %or functia patch (similara cu fill)
end
plot(start(1),start(2),'dr','MarkerSize',10,'LineWidth',2);
plot(stop(1),stop(2),'xr','MarkerSize',10,'LineWidth',2);

fill(coord_u{1}(1,:)+st(1,1),coord_u{1}(2,:)+st(2,1),'r'); %pt a ramine pozitia de start
rob_h=fill(coord_u{1}(1,:)+st(1,1),coord_u{1}(2,:)+st(2,1),'g');
set(rob_h,'EraseMode','xor')

for i=2:size(pozitia,2)
    pause((timp(i)-timp(i-1))/ft);
    x=coord_u{i}(1,:)+st(1,i);
    y=coord_u{i}(2,:)+st(2,i);
    set(rob_h,'XData',x,'YData',y);
    drawnow
end
fill(x,y,'b');
pause(1)

%urmele unicycl.
urme_h=figure();
set(urme_h,'Position',scrsz);
axis(world_dim);
axis('square');
hold on
title('The movement of the unicycle')
for i=1:obs_no
    fill(object{i}(1,:),object{i}(2,:),'k') %or functia patch (similara cu fill)
end
fill(coord_u{1}(1,:)+st(1,1),coord_u{1}(2,:)+st(2,1),'r');

int_t=0.5;
t=int_t;
for i=2:size(pozitia,2)
    [m,i]=min(abs(timp-t)); %sarim la momente de timp din int_t in int_t
    t=t+int_t;
    x=coord_u{i}(1,:)+st(1,i);
    y=coord_u{i}(2,:)+st(2,i);
    h=fill(x,y,'g');
    set(h,'FaceAlpha',0.5);
end
fill(coord_u{end}(1,:)+st(1,end),coord_u{end}(2,:)+st(2,end),'b');
