%functie pt aflarea vecinilor dreptunghiului curent
%dr este nr de ordine (coloana in matricea POZ) al dreptunghiului curent

function vecini=adiacenta(dr)
global Q POZ

a=POZ(1,dr); %a,b = coordonatele dreptunghiului curent
b=POZ(2,dr);
dims=Q{a,b}.dim; %dimensiunile dreptunghiului curent
vec=[]; %vector linie in care vor fi adaugati indicii vecinilor
Q{a,b}.N=[0;0]; %aici vom memora coordonatele vecinilor de la Nord (matrice cu 2 linii); initializam cu 0 pt. a nu obtine eroare daca accesam cimpul cu un indice
Q{a,b}.W=[0;0]; %similar pt vecinii la W,S,E
Q{a,b}.S=[0;0];
Q{a,b}.E=[0;0];

if a>1  %dreptunghiul nu este pe latura de sus, deci poate avea vecini la N
    if isempty(Q{a-1,b})    %exista un drept. liber deasupra (va fi singurul vecin de deasupra) %cazul 1 - vezi notite
        x=a-1;  %x,y vor fi coordonatele dreptunghiului vecin la Nord
        y=b-1;
        while (isempty(Q{x,y}))    %cautam coordonata y
            y=y-1;
        end
        x=Q{x,y}.coord(1);
        vec=[vec find(POZ(1,:)==x & POZ(2,:)==y)]; %cu functia find aflam nr de ordine al drept de coordonate (x,y)
        Q{a,b}.N=[Q{a,b}.N [x;y]];
    else %cazul 2 (cu mai multe subcazuri posibile)
        for i=b:(b+dims(2)-1)
            if isstruct(Q{a-1,i})
                x=Q{a-1,i}.coord(1);
                y=Q{a-1,i}.coord(2);
                dr_no=find(POZ(1,:)==x & POZ(2,:)==y); %numarul de ordine al dreptunghiului
                if (length(vec)==0) | (vec(end)~=dr_no) %ca sa nu adaugam acelasi vecin de 2 ori
                    vec=[vec dr_no];
                    Q{a,b}.N=[Q{a,b}.N [x;y]];
                end
            end
        end
    end
end

if b>1 %pot exista vecini la West
    if isempty(Q{a,b-1}) %cazul 3
        x=a-1;
        y=b-1;
        while (isempty(Q{x,y}))
            x=x-1;
        end
        y=Q{x,y}.coord(2);
        vec=[vec find(POZ(1,:)==x & POZ(2,:)==y)];
        Q{a,b}.W=[Q{a,b}.W [x;y]];
    else %cazul 4
        for i=a:(a+dims(1)-1)
            if isstruct(Q{i,b-1})
                x=Q{i,b-1}.coord(1);
                y=Q{i,b-1}.coord(2);
                dr_no=find(POZ(1,:)==x & POZ(2,:)==y);
                if (length(vec)==0) | (vec(end)~=dr_no)
                    vec=[vec dr_no];
                    Q{a,b}.W=[Q{a,b}.W [x;y]];
                end
            end
        end
    end
end

if ((a+dims(1)-1) < size(Q,1)) %nr de linii al lui Q este egal cu cel al matricei WORLD; vecini la South
    if isempty(Q{a+dims(1),b}) %cazul 5
        x=a+dims(1);
        y=b-1;
        while (isempty(Q{x,y}))
            y=y-1;
        end
        vec=[vec find(POZ(1,:)==x & POZ(2,:)==y)];
        Q{a,b}.S=[Q{a,b}.S [x;y]];
    else %cazul 6
        for i=b:(b+dims(2)-1)
            if isstruct(Q{a+dims(1),i})
                x=Q{a+dims(1),i}.coord(1);
                y=Q{a+dims(1),i}.coord(2);
                dr_no=find(POZ(1,:)==x & POZ(2,:)==y);
                if (length(vec)==0) | (vec(end)~=dr_no)
                    vec=[vec dr_no];
                    Q{a,b}.S=[Q{a,b}.S [x;y]];
                end
            end
        end
    end
end

if ((b+dims(2)-1) < size(Q,2)) %vecini la East
    if isempty(Q{a,b+dims(2)}) %cazul 7
        x=a-1;
        y=b+dims(2);
        while (isempty(Q{x,y}))
            x=x-1;
        end
        vec=[vec find(POZ(1,:)==x & POZ(2,:)==y)];
        Q{a,b}.E=[Q{a,b}.E [x;y]];
    else %cazul 8
        for i=a:(a+dims(1)-1)
            if isstruct(Q{i,b+dims(2)})
                x=Q{i,b+dims(2)}.coord(1);
                y=Q{i,b+dims(2)}.coord(2);
                dr_no=find(POZ(1,:)==x & POZ(2,:)==y);
                if (length(vec)==0) | (vec(end)~=dr_no)
                    vec=[vec dr_no];
                    Q{a,b}.E=[Q{a,b}.E [x;y]];
                end
            end
        end
    end
end

vecini=vec; %vectorul vec contine indicii vecinilor drept curent
