%functie pt. "procesarea" caii gasite
function [coord,dir]=proc_path(way,dx,dy,x_min,y_max,m,n)

%dx,dy-precizia pe oriz/vert, m,n-nr pixeli pe oriz/vert, way-calea (deja taiata daca era nevoie)

%functia va stoca coordonatele (in continuu) ale virfurilor
%dreptunghiurilor de pe cale (deja taiata) intr-o matrice de 4 coloane
%o linie va fi de forma [x1 x2 y1 y2], nr de linii va fi egal cu nr de
%dreptunghiuri din cale, ordonate in sensul trecerii prin ele

%vectorul dir va arata directia in care iesim din dreptunghiul curent:
% dir(i)==1 -> iesim prin Nord
% dir(i)==2 -> iesim prin West
% dir(i)==3 -> iesim prin South
% dir(i)==4 -> iesim prin East
% dir(i)==0 -> raminem in dreptunghi

global Q POZ

coord=zeros(length(way),4); %matricea care va contine coordonatele
direct=zeros(1,length(way)); %vector pt directii

%coordonatele drept. destinatie (nu il introduce in for, din cauza crearii vect. dir):
%formulele de calcul pt varfurile drept. (si eliminarea spatiilor libere) sint in caiet
a=POZ(1,way(end));
b=POZ(2,way(end));
dims=Q{a,b}.dim;
if b~=1
    x1=(b-1.5)*dx+x_min;
else
    x1=(b-1)*dx+x_min;
end
if (b+dims(2)-1)~=m
    x2=(b+dims(2)-1.5)*dx+x_min;
else
    x2=(b+dims(2)-2)*dx+x_min;
end
if (a+dims(1)-1)~=n
    y1=y_max-(a+dims(1)-1.5)*dy;
else
    y1=y_max-(a+dims(1)-2)*dy;
end
if a~=1
    y2=y_max-(a-1.5)*dy;
else
    y2=y_max-(a-1)*dy;
end
coord(end,:)=[x1 x2 y1 y2];

for i=(length(way)-1):-1:1 %parcurgem calea in sens invers, fara drept. destinatie (pt. care va ramine directia=0)
    vec=adiacenta(way(i)); %reactualizarea vecinilor drept. cu nr de ordine i
    a=POZ(1,way(i)); %a,b = coordonatele dreptunghiului curent
    b=POZ(2,way(i));
    dims=Q{a,b}.dim;
    dr_urm=POZ(:,way(i+1)); %coord. dreptunghiul urmator (de indice (i+1))
    if ~isempty(find(Q{a,b}.N(1,:)==dr_urm(1) & Q{a,b}.N(2,:)==dr_urm(2))) %drept. urmator e la N fata de i
        direct(i)=1;
    elseif ~isempty(find(Q{a,b}.W(1,:)==dr_urm(1) & Q{a,b}.W(2,:)==dr_urm(2)))
        direct(i)=2;
    elseif ~isempty(find(Q{a,b}.S(1,:)==dr_urm(1) & Q{a,b}.S(2,:)==dr_urm(2)))
        direct(i)=3;
    elseif ~isempty(find(Q{a,b}.E(1,:)==dr_urm(1) & Q{a,b}.E(2,:)==dr_urm(2)))
        direct(i)=4;
    end
    %calculul coordonatelor (in continuu)
    if b~=1
        x1=(b-1.5)*dx+x_min;
    else
        x1=(b-1)*dx+x_min;
    end
    if (b+dims(2)-1)~=m
        x2=(b+dims(2)-1.5)*dx+x_min;
    else
        x2=(b+dims(2)-2)*dx+x_min;
    end
    if (a+dims(1)-1)~=n
        y1=y_max-(a+dims(1)-1.5)*dy;
    else
        y1=y_max-(a+dims(1)-2)*dy;
    end
    if a~=1
        y2=y_max-(a-1.5)*dy;
    else
        y2=y_max-(a-1)*dy;
    end
    coord(i,:)=[x1 x2 y1 y2];
end

dir=direct;
