function [st]=traseu_unicyc(P0,timp,viteza,epsilon)
%functie pt gasirea traseului unicycle-ului, avind vitezele punctului
%observabil (formule in caiet)
%P0-starea initiala a unicycleului (dist.x 0, dist.y 0, theta 0)
%timp,viteza-se refera la miscarea punctului observabil (aflat la dist epsilon de centru)
%date iesire:
%st-vectorul de stare, de forma [dx;dy;theta], la momentele din vectorul timp (de la integrarea anterioara)
%(d- vectorul pozitiei centrului unicyc; th-unghiul unicyc cu axa orizontala)

[t,st]=ode45(@unicy,timp,P0,[],timp,viteza,epsilon); %integrare la momentele de timp deja aflate (de la integrarea anterioara)
st=st';

function d_st=unicy(t,st,timp,viteza,epsilon)
[m,ind]=min(abs(timp-t)); %ind este indicele timpului cel mai apropiat de t din vectorul timp (pt a aproxima viteza la momentul t)
d_st=[cos(st(3))^2 , sin(st(3))*cos(st(3));sin(st(3))*cos(st(3)) , sin(st(3))^2;-sin(st(3))/epsilon , cos(st(3))/epsilon]*viteza(:,ind);
