clear global
clear all
close all
clc

%CREATE WORLD
%reading data & display

%o1=[0 -2 -3;-4 0 0;-1 -1 2;5 4 3;0 0 0]'; %coordonatele virfurilor unui obs. (matrice cu 3 linii)
obs{1}=[-8 -7 -8;-2 -9 -5;-5 -5 -2;-4 -2 -7]';
obs{2}=[0 0 3;-2 4 6;3 3 2;2 4 5;-3 3 1;-1 5 4]';
obs{3}=[5 -9 -1;7 -7 -1;9 -5 3;8 -1 2;7 0 3;3 -3 -1;6 0 4;3 -2 8;4 -4 8]';
obs{4}=[-8 6 7;-6 9 8;-9 7 5;-8 9 9;-8 7 4;-9 3 10;-6 2 9]';
obs{5}=[-3 -8 -3;-3 -9 2;4 -5 5;3 -4 7;2 -5 6;0 -4 3;2 -3 4]';
obs{6}=[3 3 -8;5 4 -5;8 7 -3;6 7 -2;6 8 -4;4 3 -3;4 7 -4;3 5 -6]';
obs{7}=[-7 1 -2;-5 0 4;-4 3 3;-6 5 2;-7 6 2;-8 5 -1;-6 4 4;-5 3 3]';
obs{8}=[-3 -2 -8;0 -2 -7;3 2 -6;2 5 -3;-2 6 -3;-4 -3 -6;-4 -2 -4;-1 4 0;2 3 0;-2 -4 -5;0 -4 -2;]';
obs{9}=[6 2 5;8 3 6;9 5 4;6 7 7;5 4 3;4 4 8;8 4 3]';
obs{10}=[-8 -3 8;-3 -7 4;-5 -5 5;-3 -3 8;-8 -7 4]';
obs{11}=[-3 5 -1;-3 8 4;0 5 -1;0 7 4;0 5 4;-3 8 4;-2 7 3]';
obs_no=size(obs,2);

rob=[-1 -1 -1;-1 -1 1;-1 1 -1;-1 1 1;1 -1 -1;1 -1 1;1 1 -1;1 1 1]'/2; %un cub cu latura 1

scrsz = get(0,'ScreenSize');
scrsz(4)=scrsz(4)-72;

%world_dim=input('Define world ([x_min x_max y_min y_max z_min z_max]): ');
world_dim=[-10 10 -10 10 -10 10];

%definirea robotului si reprezentarea sa
%rob=input('Robot vertices with respect to its centroid (3xN matrix): ');
robot=afla_interior(rob);
rob_fig=figure();
title('Robot vertices')
axis(world_dim/5);
grid
view([world_dim(2) world_dim(4) world_dim(6)]/5)
r_h=plot_obs(robot,'r',0.5);
pause(2)
close(rob_fig);

%definirea spatiului vitezelor robotului
%spd=input('Robot''s speed domain (containing origin) (3xN matrix): ');
spd=2*rob;
[V,A_V,b_V]=afla_interior(spd);
spd_fig=figure();
title('Robot''s speed boundaries')
axis(world_dim/5);
grid
view([world_dim(2) world_dim(4) world_dim(6)]/5)
spd_h=plot_obs(V,'b',0.5);
pause(2)
close(spd_fig);

%definirea obstacolelor
% obs_no=input('Number of obstacles: ');
% obs=cell(1,obs_no);
% for i=1:obs_no
%     fprintf('\nCoordinates of obstacle %g (matrix with 3 lines):\n',i)
%     obs{i}=input('');
% end

%reprezentarea obstacolelor
init_world_h=figure();
set(init_world_h,'Position',scrsz);
title('Obstacles')
hold on
axis(world_dim)
view([world_dim(2) world_dim(4) world_dim(6)])
xlabel('x-dim');
ylabel('y-dim');
zlabel('z-dim');
grid
for i=1:obs_no
    obs_c=afla_interior(obs{i}); %virfurile ce definesc convex-hull-ul obstacolului
    plot_obs(obs_c,'r',1);
end
pause(2)

title('Enlarged obstacles')
%micsorarea granitelor spatiului (pt a reduce robotul la un punct)
wrld = world_dim - [min(robot(1,:)) max(robot(1,:)) min(robot(2,:)) max(robot(2,:)) min(robot(3,:)) max(robot(3,:))];
%reprezentarea granitelor
x=wrld(1);x2=wrld(2);y=wrld(3);y2=wrld(4);z=wrld(5);z2=wrld(6);
mat_vf=[x y z;x2 y z;x y2 z;x y z2;x2 y2 z;x2 y z2;x y2 z2;x2 y2 z2];
mat_fete=[1 2 5 3;1 2 6 4;1 3 7 4;4 6 8 7;3 5 8 7;2 5 8 6];
patch('Vertices',mat_vf,'Faces',mat_fete,'FaceColor','w','FaceAlpha',0); %similar cu functia plot_desc8

%largirea obstacolelor (pt a reduce robotul la centrul sau)
obstacle=cell(1,obs_no);
for i=1:obs_no                  %pt fiecare obstacol
    obs_t=[]; %matrice temporara
    for j=1:size(obs{i},2)      %pt fiecare virf al obstacolului (ne-convex)
        for k=1:size(rob,2)     %pt fiecare virf al robotului (ne-convex)
            obs_t=[obs_t obs{i}(:,j)-rob(:,k)];
        end
    end
    [C,A,b,N]=afla_interior(obs_t);
    obstacle{i}.vf_c=C;
    obstacle{i}.A=A;
    obstacle{i}.b=b;
    obstacle{i}.N=N;
    plot_obs(C,'b',0.5);
end
pause(1)
set(init_world_h,'Visible','off')


dt=input('Integration step size: ');
disp('')
%BINARIZAREA
m=input('Resolution on X dimension (in percent, aprox. value): [%] ');
n=input('Resolution on Y dimension (in percent, aprox. value): [%] ');
p=input('Resolution on Z dimension (in percent, aprox. value): [%] ');
m=2^round(log2(100/m)); %nr de pixeli pe dimensiunea 1
n=2^round(log2(100/n)); %nr de pixeli pe dim 2
p=2^round(log2(100/p)); %nr de pixeli pe dim 3

fprintf('\nBinarized image (hidden from user) will have %g x %g x %g pixels\n\n',n,m,p);

global WORLD
WORLD=ones(p,m,n);

d_x=wrld(2)-wrld(1);
d_y=wrld(4)-wrld(3);
d_z=wrld(6)-wrld(5);
x_min=wrld(1);
y_max=wrld(4);
z_max=wrld(6);

dx=d_x/(m-1);
dy=d_y/(n-1);
dz=d_z/(p-1);
disp('binarizare');tic; %***
for i=1:obs_no
    v_a=round((z_max-obstacle{i}.vf_c(3,:))/dz+1); %coordonatele virfurilor in discret
    v_b=round((obstacle{i}.vf_c(1,:)-x_min)/dx+1); %in discret, matricea are indicii a,b,c
    v_c=round((y_max-obstacle{i}.vf_c(2,:))/dy+1);
    obstacle{i}.vf_d=[v_a;v_b;v_c];
    umple_obs(obstacle{i},dx,dy,dz,x_min,y_max,z_max,m,n,p)
end
toc %***

%punctele de start, stop
er=1;
while er==1
start=input('Coordinates of the start point [x;y;z]: ');
start_d=[round((z_max-start(3))/dz+1);round((start(1)-x_min)/dx+1);round((y_max-start(2))/dy+1)];
if WORLD(start_d(1),start_d(2),start_d(3))==0
    fprintf('\n\nThe robot can''t start from the inside an obstacle! Please try again.\n')
else
    er=0;
end
end
er=1;
while er==1
stop=input('Coordinates of the stop point [x;y;z]: ');
stop_d=[round((z_max-stop(3))/dz+1);round((stop(1)-x_min)/dx+1);round((y_max-stop(2))/dy+1)];
if WORLD(stop_d(1),stop_d(2),stop_d(3))==0
    fprintf('\n\nThe robot can''t stop inside an obstacle! Please try again.\n')
else
    er=0;
end
end

% %vizualizarea proiectiilor matricei WORLD
% pr1=double(uint8(squeeze(sum(WORLD,1))-m+1)); %proiectia pe dim 1
% imshow(pr1);

%impartirea in oct-trees
global Q POZ
Q=cell(size(WORLD));
Q{1,1,1}.coord=[1;1;1];
Q{1,1,1}.dim=size(WORLD)';
test_paralelip(1,1,1);

%reprezentarea spatiului cu ostacolele marite
new_wrld_h=figure();
title('Enlarged obstacles')
set(new_wrld_h,'Position',scrsz);
hold on
axis(wrld)
view([wrld(2) wrld(4) wrld(6)])
xlabel('x-dim');
ylabel('y-dim');
zlabel('z-dim');
grid
for i=1:obs_no
    plot_obs(obstacle{i}.vf_c,'r',1);
end

title('Rectangular parallelepiped decomposition')
%reprezentarea primei descompuneri in paralepipede
nr_p=size(POZ,2); %nr de paralelipipede
for i=1:nr_p
    plot_desc8(i,dx,dy,dz,x_min,y_max,z_max,'b',0.1);
end

%matricea de adiacenta
global ADIACENT ADIAC_W
ADIACENT=zeros(nr_p);
ADIAC_W=Inf(nr_p);
coord_r=zeros(nr_p,3); %centrele paralelipipedelor
disp('adiacenta');tic; %***
for i=1:nr_p
    a=POZ(1,i);
    b=POZ(2,i);
    c=POZ(3,i);
    dims=Q{a,b,c}.dim;
    coord_r(i,:)=[((2*b+dims(2)-3)*dx/2+x_min) (y_max-(2*c+dims(3)-3)*dy/2) (z_max-(2*a+dims(1)-3)*dz/2)];
    vol=(dims(1)-1)*(dims(2)-1)*(dims(3)-1)*dx*dy*dz; %volumul
    aria=(dims(1)-1)*(dims(2)-1)*dx*dy+(dims(2)-1)*(dims(3)-1)*dy*dz+(dims(3)-1)*(dims(1)-1)*dz*dx; %1/2 din suprafata
    
    vecini=adiacenta_paralelip(i);
    ADIACENT(vecini,i)=1;
    %ADIAC_W(vecini,i)=aria/vol;
    ADIAC_W(vecini,i)=2*(dims(1)*dims(2)+dims(2)*dims(3)+dims(1)*dims(3))/(dims(1)*dims(2)*dims(3)); %arie/volum calculata binar - pt a elimina erorile de conversie
end
toc %***
%reprezentarea grafului 3D (functia gplot ar fi reprezentat proiectia 2D: gplot(ADIACENT,coord_r,'.-r')
for i=1:nr_p
    for j=find(ADIACENT(:,i)~=0)' %indicii vecinilor lui i
        plot3([coord_r(i,1) coord_r(j,1)],[coord_r(i,2) coord_r(j,2)],[coord_r(i,3) coord_r(j,3)],'.-r')
    end
end

%punctele de start si stop ale centrului robotului
plot3(start(1),start(2),start(3),'dg','MarkerSize',10,'LineWidth',2);
plot3(stop(1),stop(2),stop(3),'xg','MarkerSize',10,'LineWidth',2);
%par de start si stop
for i=1:nr_p
    a=POZ(1,i);
    b=POZ(2,i);
    c=POZ(3,i);
    dims=Q{a,b,c}.dim;
    vf1=POZ(:,i);
    vf2=vf1+dims-1;
    if vf1<=start_d & start_d<=vf2
        par_start=i;
    end
    if vf1<=stop_d & stop_d<=vf2
        par_stop=i;
    end
end

%calea initiala start-stop
disp('cale I');tic; %***
if par_start~=par_stop
    cale=find_path(par_start,par_stop);
else
    cale=par_start; %raminem in acelasi paralepiped
end
nr_p=length(cale); %nr de noduri din cale
toc %***

title('First path')
%reprezentarea caii
if nr_p~=1
    for i=1:nr_p-1
        path_h(i)=plot3([coord_r(cale(i),1) coord_r(cale(i+1),1)],[coord_r(cale(i),2) coord_r(cale(i+1),2)],[coord_r(cale(i),3) coord_r(cale(i+1),3)],'o-g','LineWidth',2,'MarkerSize',10);
        pause(0.05)
    end
elseif cale~=0 %lungimea caii este 1, deci raminem in acelasi dreptunghi
    path_h=plot3(coord_r(cale(1),1),coord_r(cale(1),2),coord_r(cale(1),3),'o-g','LineWidth',2,'MarkerSize',10);
else
    title('Path start->stop not found');
    fprintf('\n\nPath start->stop not found!\n\n');
end
way=cale;
%taierea paralep prea mari din calea gasita
disp('cale II');tic; %***
if nr_p~=1
    cale=split_path_par(cale,start_d);
    cale=fliplr(split_path_par(fliplr(cale),stop_d));
end
toc %***

title('Path of the robot''s centroid')
%reprezentarea caii obtinute dupa taieri
pause(1)
delete(path_h);
for i=cale
    plot_desc8(i,dx,dy,dz,x_min,y_max,z_max,'g',0.5);
    pause(0.05)
end
pause(2)
set(new_wrld_h,'Visible','off')
%close(new_wrld_h)


nr_p=length(cale); % caii finale
%directiile in care se iese din fiecare paral
[coord,dir]=proc_path_par(cale,dx,dy,dz,x_min,y_max,z_max,m,n,p);

%reprezentarea paralep din cale (in figura doar cu obs marite)
title('Path of the robot''s centroid')
set(init_world_h,'Visible','on')
plot3(start(1),start(2),start(3),'db','MarkerSize',10,'LineWidth',2);
for i=1:nr_p
    x1=coord(i,1);
    x2=coord(i,2);
    y1=coord(i,3);
    y2=coord(i,4);
    z1=coord(i,5);
    z2=coord(i,6);
    mat_vf=[x1 y2 z2;x2 y2 z2;x1 y1 z2;x1 y2 z1;x2 y1 z2;x2 y2 z1;x1 y1 z1;x2 y1 z1];
    mat_fete=[1 2 5 3;1 2 6 4;1 3 7 4;4 6 8 7;3 5 8 7;2 5 8 6];
    par_h(i)=patch('Vertices',mat_vf,'Faces',mat_fete,'EdgeColor','y','LineWidth',2,'FaceColor','y','FaceAlpha',0.1);
    pause(0.1)
end
plot3(stop(1),stop(2),stop(3),'xb','MarkerSize',10,'LineWidth',2);

%aflarea g la virfuri si reprez vf
title('Vector field')
G=alege_g_par(coord,dir,A_V,b_V,stop);
for i=1:nr_p
    camlookat(par_h(i));
    plot_vf_par(coord(i,:),G{i},dx,dy,dz,'g');
    pause(0.5)
end
pause(1)
camlookat
view([world_dim(2) world_dim(4) world_dim(6)]);

%aflarea traseului urmat de centroidul robotului
d_min=norm([dx;dy;dz])/10;
[timp,pozitia,viteza]=traseu_pas_cst_par(start,coord(1,:),G{1},stop,d_min,dt);
for i=2:nr_p
    p_init=pozitia(:,end);
    if norm(p_init-stop)<=d_min
        break
    end
    [t,poz,vit]=traseu_pas_cst_par(p_init,coord(i,:),G{i},stop,d_min,dt);
    timp=[timp timp(end)+t(2:end)];
    pozitia=[pozitia poz(:,2:end)];
    viteza=[viteza vit(:,2:end)];
end

c_t_init=camtarget;
c_p_init=campos;
c_a_init=camva;
plot3(pozitia(1,1),pozitia(2,1),pozitia(3,1),'.r')
for i=2:size(pozitia,2)
    campos(pozitia(:,i-1)) %camera position
    camtarget(pozitia(:,i)) %target
    camva(160) %view angle
    drawnow
    plot3(pozitia(1,(i-1:i)),pozitia(2,(i-1:i)),pozitia(3,(i-1:i)),':.r')
end
pause(1)
camtarget(c_t_init);
campos(c_p_init);
camva(c_a_init);
pause(2)

%reprezentarea proiectiilor vitezei centrului robotului
vit_h=figure();
title('Robot''s speed projections')
set(vit_h,'Position',scrsz);
subplot(311);
plot(timp,viteza(1,:),'.k')
xlabel('X speed projection')
subplot(312);
plot(timp,viteza(2,:),'.k')
xlabel('Y speed projection')
subplot(313);
plot(timp,viteza(3,:),'.k')
xlabel('Z speed projection')
pause(1.5);


%reprez miscarii robotului
world_h=figure();
title('Movement')
set(world_h,'Position',scrsz);
hold on
grid
axis(world_dim)
view([world_dim(2) world_dim(4) world_dim(6)])
xlabel('x-dim');
ylabel('y-dim');
zlabel('z-dim');

for i=1:obs_no
    obs_c=afla_interior(obs{i});
    plot_obs(obs_c,'b',0.7);
end
plot3(start(1),start(2),start(3),'dg','MarkerSize',10,'LineWidth',2);
plot3(stop(1),stop(2),stop(3),'xg','MarkerSize',10,'LineWidth',2);
rob_h=plot_obs(robot+pozitia(:,1)*ones(1,size(robot,2)),'r',1);

d_r=25*max(max(rob,[],2)-min(rob,[],2)); %distanta la care va fi camera de robot
c_t_init=camtarget;
c_p_init=campos;

campos([world_dim(2) world_dim(4) world_dim(6)]*5)
for i=2:size(pozitia,2)
    camva('manual')
    c_t=pozitia(:,i);
    %c_p=pozitia(:,i-1)-pozitia(:,i);
    %c_p=pozitia(:,i)+d_r*c_p/norm(c_p);
    %     x=robot(1,:)+pozitia(1,i);
    %     y=robot(2,:)+pozitia(2,i);
    %     z=robot(3,:)+pozitia(3,i);
    %     set(rob_h,'XData',x,'YData',y,'ZData',z);
    delete(rob_h);
    rob_h=plot_obs(robot+pozitia(:,i)*ones(1,size(robot,2)),'r',1);
    camtarget(c_t);
    %campos(c_p);
    drawnow
end
delete(rob_h)

camtarget(c_t_init);
campos(c_p_init);

for i=1:10:size(pozitia,2) %urmele (din 10 in 10 int de timp)
    plot_obs(robot+pozitia(:,i)*ones(1,size(robot,2)),'r',0.3);
    pause(dt/5)
end
plot_obs(robot+pozitia(:,end)*ones(1,size(robot,2)),'b',0.3);
