%functie pt aflarea vecinilor paralelipipedului curent
%par este nr de ordine (coloana in matricea POZ) al paralelipipedului curent
function vecini=adiacenta_paralelip(par)
global Q POZ

a=POZ(1,par); %a,b,c-coordonatele paralelipipedului curent
b=POZ(2,par);
c=POZ(3,par);
dims=Q{a,b,c}.dim;

vec=[]; %vector linie in care vor fi adaugati indicii vecinilor
Q{a,b,c}.U=[0;0;0]; %aici vom memora coordonatele vecinilor U-up, D-down, Forward (in fata, c mai mic - spre cel care se uita),Back (c  mai mare), L, R
Q{a,b,c}.D=[0;0;0];
Q{a,b,c}.F=[0;0;0];
Q{a,b,c}.B=[0;0;0];
Q{a,b,c}.L=[0;0;0];
Q{a,b,c}.R=[0;0;0];

if a>1  %par nu este pe latura de sus, deci poate avea vecini U
    for i=b:(b+dims(2)-1)
        for j=c:(c+dims(3)-1)
            if isstruct(Q{a-1,i,j})
                x=Q{a-1,i,j}.coord(1);
                y=Q{a-1,i,j}.coord(2);
                z=Q{a-1,i,j}.coord(3);
                par_no=find(POZ(1,:)==x & POZ(2,:)==y & POZ(3,:)==z);
                if isempty(find(vec==par_no))
                    vec=[vec par_no];
                    Q{a,b,c}.U=[Q{a,b,c}.U [x;y;z]];
                end
            end
        end
    end
end

if b>1 %pot exista vecini L
    for i=a:(a+dims(1)-1)
        for j=c:(c+dims(3)-1)
            if isstruct(Q{i,b-1,j})
                x=Q{i,b-1,j}.coord(1);
                y=Q{i,b-1,j}.coord(2);
                z=Q{i,b-1,j}.coord(3);
                par_no=find(POZ(1,:)==x & POZ(2,:)==y & POZ(3,:)==z);
                if isempty(find(vec==par_no))
                    vec=[vec par_no];
                    Q{a,b,c}.L=[Q{a,b,c}.L [x;y;z]];
                end
            end
        end
    end
end

if c>1 %vecini F
    for i=a:(a+dims(1)-1)
        for j=b:(b+dims(2)-1)
            if isstruct(Q{i,j,c-1})
                x=Q{i,j,c-1}.coord(1);
                y=Q{i,j,c-1}.coord(2);
                z=Q{i,j,c-1}.coord(3);
                par_no=find(POZ(1,:)==x & POZ(2,:)==y & POZ(3,:)==z);
                if isempty(find(vec==par_no))
                    vec=[vec par_no];
                    Q{a,b,c}.F=[Q{a,b,c}.F [x;y;z]];
                end
            end
        end
    end
end

if ((a+dims(1)-1) < size(Q,1)) %vecini D
    for i=b:(b+dims(2)-1)
        for j=c:(c+dims(3)-1)
            if isstruct(Q{a+dims(1),i,j})
                x=Q{a+dims(1),i,j}.coord(1);
                y=Q{a+dims(1),i,j}.coord(2);
                z=Q{a+dims(1),i,j}.coord(3);
                par_no=find(POZ(1,:)==x & POZ(2,:)==y & POZ(3,:)==z);
                if isempty(find(vec==par_no))
                    vec=[vec par_no];
                    Q{a,b,c}.D=[Q{a,b,c}.D [x;y;z]];
                end
            end
        end
    end
end

if ((b+dims(2)-1) < size(Q,2)) %vecini R
    for i=a:(a+dims(1)-1)
        for j=c:(c+dims(3)-1)
            if isstruct(Q{i,b+dims(2),j})
                x=Q{i,b+dims(2),j}.coord(1);
                y=Q{i,b+dims(2),j}.coord(2);
                z=Q{i,b+dims(2),j}.coord(3);
                par_no=find(POZ(1,:)==x & POZ(2,:)==y & POZ(3,:)==z);
                if isempty(find(vec==par_no))
                    vec=[vec par_no];
                    Q{a,b,c}.R=[Q{a,b,c}.R [x;y;z]];
                end
            end
        end
    end
end

if ((c+dims(3)-1) < size(Q,3)) %vecini B
    for i=a:(a+dims(1)-1)
        for j=b:(b+dims(2)-1)
            if isstruct(Q{i,j,c+dims(3)})
                x=Q{i,j,c+dims(3)}.coord(1);
                y=Q{i,j,c+dims(3)}.coord(2);
                z=Q{i,j,c+dims(3)}.coord(3);
                par_no=find(POZ(1,:)==x & POZ(2,:)==y & POZ(3,:)==z);
                if isempty(find(vec==par_no))
                    vec=[vec par_no];
                    Q{a,b,c}.B=[Q{a,b,c}.B [x;y;z]];
                end
            end
        end
    end
end

vecini=vec; %vectorul vec contine indicii vecinilor drept curent
