function [C,A,b,N]=afla_interior(vf)
%vf este o matrice (cu 3 linii) care contine virfurile unui corp in 3D
%matricea C va fi o matrice cu 3 linii si nr de coloane divizibil cu 3,
%care contine virfurile ce definesc convex-hull-ul (din virfurile vf)
%primele 3 coloane din C definesc o fata, samd
%functia afla matricea A si vectorul b, a.i. punctul de coordonate X
%este in interiorul convex-hull-ului daca si numai daca AX<=b

j=convhulln(vf');
C=vf(:,j'); %matricea C

N=size(C,2)/3; %nr de fete ale conv-hull

A=zeros(N,3);
b=zeros(N,1);
centr=mean(C,2); %coordonatele centroidului

for i=1:N
    j=(i-1)*3+1; %indicele primului virf din fata i
    n=cross(C(:,j+1)-C(:,j),C(:,j+2)-C(:,j)); %directia normalei fetei i
    n=n/norm(n); %n vector unitate
    if n'*(C(:,j)-centr)<0 %alegem directia lui n a.i. sa fie outer normal
        n=-n;
    end
    A(i,:)=n';
    b(i)=n'*C(:,j);
end
