%functie pt gasirea caii de cost minim (costul proportional cu supr/vol)
%folosind algoritmul Dijkstra (putin modificat pt problema noastra)

function cale=find_path(s,d) %s-indicele paralepipedului sursa, d-ind paralep destinatie

global ADIAC_W

n=size(ADIAC_W,1); %nr de dreptunghiuri (noduri in graf)

visited=zeros(n,1); %daca un nod a fost sau nu luat in calcul
dist=Inf(n,1); %distantele de la sursa pina la noduri (se vor modifica pe parcurs)
dist(s)=0;
predec=zeros(n,1); %predecesorul fiecarui dreptunghi (nod)

%parcurgerea pina se viziteaza toate nodurile (alg. Dijkstra)
while sum(visited)~=n
    d_m=min(dist(find(visited==0))); %distanta minima fata de sursa, considerind doar nodurile nevizitate
    x=find(dist==d_m & visited==0); %x este nodul curent (aflat la distanta d_m de sursa)
    x=x(1); %in cazul in care sint mai multe noduri cu aceeasi arie (distanta); vor fi luate pe rind, la urmatoarele iteratii
    visited(x)=1;
    vecini=find(isfinite(ADIAC_W(x,:)) & visited'==0); %vecinii nevizitati ai nodului curent, considerind tranzitia din x spre vecini
    if length(vecini)==0
       continue %nodul curent nu mai are vecini, continuam cu urmatoarea iteratie (cu nodurile nevisitate de pe alte "ramuri")
    end
    for i=vecini %pt fiecare vecin nevizitat modificam distanta (daca este mai mica decit anterior)
        if (dist(i) > dist(x)+ADIAC_W(x,i))
            dist(i)=dist(x)+ADIAC_W(x,i);
            predec(i)=x;
        end
    end
end

%gasirea caii spre destinatia dorita
if dist(d)~=Inf %exista o cale sursa -> destinatie
    cale_temp=[d]; %vom obtine calea s->d
    nod=d; %nod temporar
    while predec(nod)~=s
        nod=predec(nod);
        cale_temp=[nod cale_temp];
    end
    cale=[s cale_temp];
else
    cale=0; %nu exista cale s->d (pt ca obstacolele obtureaza orice traseu s-d)
end
