%functie pt. "procesarea" caii gasite
function [coord,dir]=proc_path(way,dx,dy,dz,x_min,y_max,z_max,m,n,p)

%functia va stoca coordonatele (in continuu) virfurilor
%paralep de pe cale (deja taiata) intr-o matrice de 6 coloane
%o linie va fi de forma [x1 x2 y1 y2 z1 z2], nr de linii va fi egal cu nr de
%par din cale, ordonate in sensul trecerii prin ele (x1<x2,y1<y2,z1<z2)

%vectorul dir va arata directia in care iesim din par curent:
% dir(i)==1 -> iesim U
% dir(i)==2 -> L
% dir(i)==3 -> F
% dir(i)==4 -> D
% dir(i)==5 -> R
% dir(i)==6 -> B
% dir(i)==0 -> raminem in interior

global Q POZ

coord=zeros(length(way),6);
direct=zeros(1,length(way));

%paralep destinatie (nu il introduce in for); se elimina spatiile libere
a=POZ(1,way(end));
b=POZ(2,way(end));
c=POZ(3,way(end));
dims=Q{a,b,c}.dim;
if b~=1
    x1=(b-1.5)*dx+x_min;
else
    x1=(b-1)*dx+x_min;
end
if (b+dims(2)-1)~=m
    x2=(b+dims(2)-1.5)*dx+x_min;
else
    x2=(b+dims(2)-2)*dx+x_min;
end
if (c+dims(3)-1)~=n
    y1=y_max-(c+dims(3)-1.5)*dy;
else
    y1=y_max-(c+dims(3)-2)*dy;
end
if c~=1
    y2=y_max-(c-1.5)*dy;
else
    y2=y_max-(c-1)*dy;
end
if (a+dims(1)-1)~=p
    z1=z_max-(a+dims(1)-1.5)*dz;
else
    z1=z_max-(a+dims(1)-2)*dz;
end
if a~=1
    z2=z_max-(a-1.5)*dz;
else
    z2=z_max-(a-1)*dz;
end
coord(end,:)=[x1 x2 y1 y2 z1 z2];

for i=(length(way)-1):-1:1
    vec=adiacenta_paralelip(way(i));
    a=POZ(1,way(i));
    b=POZ(2,way(i));
    c=POZ(3,way(i));
    dims=Q{a,b,c}.dim;
    par_urm=POZ(:,way(i+1));
    if ~isempty(find(Q{a,b,c}.U(1,:)==par_urm(1) & Q{a,b,c}.U(2,:)==par_urm(2) & Q{a,b,c}.U(3,:)==par_urm(3)))
        direct(i)=1;
    elseif ~isempty(find(Q{a,b,c}.L(1,:)==par_urm(1) & Q{a,b,c}.L(2,:)==par_urm(2) & Q{a,b,c}.L(3,:)==par_urm(3)))
        direct(i)=2;
    elseif ~isempty(find(Q{a,b,c}.F(1,:)==par_urm(1) & Q{a,b,c}.F(2,:)==par_urm(2) & Q{a,b,c}.F(3,:)==par_urm(3)))
        direct(i)=3;
    elseif ~isempty(find(Q{a,b,c}.D(1,:)==par_urm(1) & Q{a,b,c}.D(2,:)==par_urm(2) & Q{a,b,c}.D(3,:)==par_urm(3)))
        direct(i)=4;
    elseif ~isempty(find(Q{a,b,c}.R(1,:)==par_urm(1) & Q{a,b,c}.R(2,:)==par_urm(2) & Q{a,b,c}.R(3,:)==par_urm(3)))
        direct(i)=5;
    elseif ~isempty(find(Q{a,b,c}.B(1,:)==par_urm(1) & Q{a,b,c}.B(2,:)==par_urm(2) & Q{a,b,c}.B(3,:)==par_urm(3)))
        direct(i)=6;
    end
    %calculul coordonatelor (in continuu)
    if b~=1
        x1=(b-1.5)*dx+x_min;
    else
        x1=(b-1)*dx+x_min;
    end
    if (b+dims(2)-1)~=m
        x2=(b+dims(2)-1.5)*dx+x_min;
    else
        x2=(b+dims(2)-2)*dx+x_min;
    end
    if (c+dims(3)-1)~=n
        y1=y_max-(c+dims(3)-1.5)*dy;
    else
        y1=y_max-(c+dims(3)-2)*dy;
    end
    if c~=1
        y2=y_max-(c-1.5)*dy;
    else
        y2=y_max-(c-1)*dy;
    end
    if (a+dims(1)-1)~=p
        z1=z_max-(a+dims(1)-1.5)*dz;
    else
        z1=z_max-(a+dims(1)-2)*dz;
    end
    if a~=1
        z2=z_max-(a-1.5)*dz;
    else
        z2=z_max-(a-1)*dz;
    end
    coord(i,:)=[x1 x2 y1 y2 z1 z2];
end

dir=direct;
